from Products.PageTemplates.TALES import Engine, CompilerError, _valid_name, NAME_RE, TALESError, Undefined, Default, _parse_expr

from Products.PageTemplates.Expressions import PathExpr, StringExpr, NotExpr, DeferExpr, LazyExpr

from ZRPythonExpr import PythonExpr

_engine = None

def getEngine():
	global _engine
	if _engine is None:
		from Products.PageTemplates.PathIterator import Iterator
		_engine = Engine(Iterator)
		installHandlers(_engine)
		_engine._nocatch = (TALESError, 'Redirect')
	return _engine

def installHandlers(engine):
	reg = engine.registerType
	pe = PathExpr
	for pt in ('standard', 'path', 'exists', 'nocall'):
		reg(pt, pe)

	reg('string', StringExpr)
	reg('python', PythonExpr)
	reg('not', NotExpr)
	reg('defer', DeferExpr)
	reg('lazy', LazyExpr)
